class Api::V1::Projects::Branches::CreateService < ApplicationService 
  include ActiveModel::Model

  attr_accessor :project, :token, :owner, :repo, :old_branch_name, :new_branch_name
  attr_accessor :gitea_data

  validates :new_branch_name, :old_branch_name, presence: true

  def initialize(project, params, token=nil)
    @project = project 
    @owner = project&.owner.login 
    @repo = project&.identifier
    @new_branch_name = params[:new_branch_name]
    @old_branch_name = params[:old_branch_name] 
    @token = token 
  end

  def call 
    raise Error, errors.full_messages.join(",") unless valid?

    check_branch_exist
    excute_data_to_gitea
    
    gitea_data
  end

  private 
  def request_params 
    {
      access_token: token 
    }
  end

  def request_body 
    {
      new_branch_name: new_branch_name,
      old_branch_name: old_branch_name,
    }
  end

  def excute_data_to_gitea 
    @gitea_data = $gitea_client.post_repos_branches_by_owner_repo(owner, repo, {body: request_body.to_json, query: request_params}) rescue nil
    raise Error, '创建分支失败！' unless @gitea_data.is_a?(Hash)
  end

  def check_branch_exist
    result = $gitea_hat_client.get_repos_branch_name_set_by_owner_repo(owner, repo, {query: request_params}) rescue nil
    raise Error, '查询分支名称失败！' unless result.is_a?(Array)
    raise Error, '旧分支不存在！' if !result.include?(@old_branch_name)
    raise Error, '新分支已存在！' if result.include?(@new_branch_name)
  end
end